<?php
/*
Plugin Name: PhotoBlog
Plugin URI: http://zxblog.laullon.com/plugin-photoblog/?lang=en
Description: Transform WP blog into a photo blog
Version: 0.10
Author: German Laullon
Author URI: http://www.laullon.com/blog
*/
/*  Copyright YEAR  PLUGIN_AUTHOR_NAME  (email : laullon@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class PhotoBlog {

	function PhotoBlog() {
	
		$this->DOC_ROOT = get_option('DOC_ROOT');
		$this->DOMAIN = get_option('DOMAIN');

		require(ABSPATH . 'wp-admin/includes/upgrade.php');

		add_filter('the_content', array(&$this, 'filtro'), 2);
		
		$sql = "CREATE TABLE wp_photoblog_count (
			id VARCHAR(255) NOT NULL ,
			count bigint(11) DEFAULT '0' NOT NULL,
			name tinytext NOT NULL,
			url VARCHAR(255) NOT NULL,
			UNIQUE KEY id (id)
		);";
		dbDelta($sql);
		
		$sql = "CREATE TABLE wp_photoblog_count_day (
			id VARCHAR(255) NOT NULL ,
			day date,
			count bigint(11) DEFAULT '0' NOT NULL,
			name tinytext NOT NULL,
			url VARCHAR(255) NOT NULL,
			UNIQUE KEY id (id,day)
		);";
		dbDelta($sql);
		
		$sql = "CREATE TABLE wp_photoblog_access (
			id bigint(11) DEFAULT '0' NOT NULL ,
			count bigint(11) DEFAULT '0' NOT NULL,
			rss boolean DEFAULT 'flase' NOT NULL,
			last_ref VARCHAR(255),
			UNIQUE KEY id (id,rss)
		);";
		dbDelta($sql);

		$this->DOC_ROOT = get_option('DOC_ROOT');
		$this->DOMAIN = get_option('DOMAIN');
	}

	/*
	    http://icant.co.uk/articles/phpthumbnails
		Function createthumb($name,$filename,$new_w,$new_h)
		creates a resized image
		variables:
		$name		Original filename
		$filename	Filename of the resized image
		$new_w		width of resized image
		$new_h		height of resized image
	*/	
	function createthumb($name,$filename,$new_w,$new_h)
	{
		if(!is_file($name)) return;
		$system=explode(".",$name);
		if (preg_match("/jpg|jpeg/",$system[1])){$src_img=imagecreatefromjpeg($name);}
		if (preg_match("/png/",$system[1])){$src_img=imagecreatefrompng($name);}
		$old_x=imageSX($src_img);
		$old_y=imageSY($src_img);
		if ($old_x > $old_y) 
		{
			$thumb_w=$new_w;
			$thumb_h=$old_y*($new_h/$old_x);
		}
		if ($old_x < $old_y) 
		{
			$thumb_w=$old_x*($new_w/$old_y);
			$thumb_h=$new_h;
		}
		if ($old_x == $old_y) 
		{
			$thumb_w=$new_w;
			$thumb_h=$new_h;
		}
		$dst_img=ImageCreateTrueColor($thumb_w,$thumb_h);
		imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y); 
		if (preg_match("/png/",$system[1]))
		{
			imagepng($dst_img,$filename); 
		} else {
			imagejpeg($dst_img,$filename); 
		}
		imagedestroy($dst_img); 
		imagedestroy($src_img); 
	}
	
	function get_exif($path,$file) {
		if(!preg_match("/jpg|jpeg/",$file)) return;
		if(!is_file("$this->DOC_ROOT$path/$file")) return;
		$exif=exif_read_data("$this->DOC_ROOT$path/$file");
		//$EXIF="No EXIF data <!--($f)-->";
		if(is_string($exif['Model']) && is_string($exif['FocalLength'])){
			#var_dump($exif);
			#echo "</br>Camara: " . $exif['Model'];
			list($numeradorL, $denominadorL) = split( '[/]', $exif["FocalLength"]);
			$focal=$numeradorL/$denominadorL;
			
			$time=$exif['ExposureTime'];
			list($t1,$t2)=split('[/]',$time);
			if($t1>1) $time=$t1/$t2;
			
			$EXIF = $exif['COMPUTED']['ApertureFNumber'] . " &#8212; " . $time . " Sec &#8212; ISO " . $exif['ISOSpeedRatings'] . " &#8212; " . $focal . " mm";
		}
		return $EXIF;
	}
	
	function get_nombre($path,$file,$alt="SIN NOMBRE")
	{
		if (file_exists("$this->DOC_ROOT$path/txt/$file.txt")) {
			$f = fopen("$this->DOC_ROOT$path/txt/$file.txt", 'r');
			$alt = fread($f, filesize("$this->DOC_ROOT$path/txt/$file.txt"));
		}
		return $alt;
	}
	
	function getImgTag($path,$file,$alt){
		if(is_file("$this->DOC_ROOT$path/$file")){
			$size=getimagesize("$this->DOC_ROOT$path/$file");
			return("<img src='$this->DOMAIN$path/$file' title='".$this->get_nombre($path,$file,$alt)."' alt='$alt' height='$size[1]' width='$size[0]' />");
		}
		return("");
	}
	
	function getImgThTag($path,$file,$alt){
		$res="<div class='error'><p>Imposible localizar la miniatura de la imagen ($path/thumb_$file)<p></div>";

		if (!file_exists("$this->DOC_ROOT$path/thumb_$file")) {
			$this->createthumb("$this->DOC_ROOT$path/$file","$this->DOC_ROOT$path/thumb_$file",150,150);
		}

		if(is_file("$this->DOC_ROOT$path/thumb_$file")){
			$size=getimagesize("$this->DOC_ROOT$path/thumb_".$file);
			$res="<img src='$this->DOMAIN$path/thumb_$file' title='".$this->get_nombre($path,$file,$alt)."' alt='$alt' height='$size[1]' width='$size[0]' />";
		}
		return($res);
	}
	
	function updateCount($path,$file,$alt){
		global $wpdb,$current_user;
		
		//comprobamos si existe el contador y si no existe lo creamos.
		$cont = $wpdb->get_var("SELECT count FROM wp_photoblog_count WHERE id='$path/$file'");
		if(!$cont){
			$wpdb->query("INSERT INTO wp_photoblog_count (id, count, name, url) VALUES ('$path/$file', 0, '".$this->get_nombre($path,$file,$alt)."', '".get_permalink()."')");
		}
		$cont = $wpdb->get_var("SELECT count FROM wp_photoblog_count_day WHERE id='$path/$file' and day=date(now())");
		if(!$cont){
			$wpdb->query("INSERT INTO wp_photoblog_count_day (id, count, name, url,day) VALUES ('$path/$file', 0, '".$this->get_nombre($path,$file,$alt)."', '".get_permalink()."',date(now()))");
		}
	
		//si hay login no se cuenta.
		if (!empty($current_user->ID)) return;
		//aumentamos el contador.
		$wpdb->query("UPDATE wp_photoblog_count SET count=(count + 1) WHERE id='$path/$file'");
		$wpdb->query("UPDATE wp_photoblog_count_day SET count=(count + 1) WHERE id='$path/$file' and day=date(now())");
	}
		
	function updateAccessCount(){
		global $wpdb,$current_user;
		
		//Contador accesos por hora
		$now = $wpdb->get_var("SELECT UNIX_TIMESTAMP(DATE_FORMAT(now(),'%y-%m-%d %H:00:00'))");
		$cont = $wpdb->get_var("SELECT count FROM wp_photoblog_access WHERE ( id='$now' and rss='".is_feed()."' )");
		if(!is_numeric($cont)){
			$res=$wpdb->query("INSERT INTO wp_photoblog_access (id, count,rss) VALUES ('$now', 0,'".is_feed()."')");
		}
		$cont2 = $wpdb->get_var("SELECT count FROM wp_photoblog_access WHERE ( id='$now' and rss='".!is_feed()."' )");
		if(!is_numeric($cont2)){
			$res=$wpdb->query("INSERT INTO wp_photoblog_access (id, count,rss) VALUES ('$now', 0,'".!is_feed()."')");
		}

		//si hay login no se cuenta.
		if (!empty($current_user->ID)) return;
		//aumentamos el contador.
		$wpdb->query("UPDATE wp_photoblog_access SET count=(count + 1),last_ref='$_SERVER[HTTP_REFERER]' WHERE id='$now' and rss='".is_feed()."'");
	}
		
	function getCount($path,$file){
		global $wpdb;
		$cont = $wpdb->get_var("SELECT count FROM wp_photoblog_count WHERE id='$path/$file'");
		return($cont);
	}
	
	function filtro($text) {
	
		if($_GET['preview']){
			global $wpdb;
			$t1=$wpdb->get_var("SHOW TABLES LIKE 'wp_photoblog_count'");
			debug("wp_photoblog_count=".$t1);
			$t2=$wpdb->get_var("SHOW TABLES LIKE 'wp_photoblog_count_day'");
			debug("wp_photoblog_count_day=".$t2);
			$t3=$wpdb->get_var("SHOW TABLES LIKE 'wp_photoblog_access'");
			debug("wp_photoblog_access=".$t3);
		}
		
		$text=str_replace("http://www.laullon.com/blog/","http://photoblog.laullon.com/",$text);
		
		if(preg_match('#<img[^>]*>#s',$text,$valores)) list($tag)=$valores; else return($text);
		debug("tag=$tag");
		if(preg_match('#src=\"(.*?)\"#s', $tag, $valores)) list(,$url)=$valores;
		
		debug("src=$url");
		if(preg_match('#(\w+://[^/]*)?(.*)#', $url, $valores)) list($url,$server,$img)=$valores;
		debug("valores=".var_export($valores,true));
		debug("DOMAIN=($this->DOMAIN)");
		debug("$server!=$this->DOMAIN (".($server!=$this->DOMAIN).")");
		
		//if(is($url) && ($server!=$this->DOMAIN)) return $text;
		
		debug("img=".$img);
		if(preg_match('#(.*)/(.*)#', $img, $valores)) list(,$path,$file)=$valores;
		debug("valores=".var_export($valores,true));
		debug("path=".$path);
		debug("file=".$file);
		if(preg_match('#alt=\"(.*?)\"#s', $tag, $valores)) list(,$alt)=$valores;
		debug("alt=".$alt);
				
		
		$tag=str_replace("(","\(",$tag);
		$tag=str_replace(")","\)",$tag);
		$tag=str_replace("?","\?",$tag);
		$text = preg_replace("#$tag#", "", $text);
		
		if(!is_feed()){
			$ntag=$this->getImgTag($path,$file,$alt);
			$this->updateCount($path,$file,$alt);
		}else{
			$ntag=$this->getImgThTag($path,$file,$alt);
		}
		$this->updateAccessCount($file);
		
		$txt="<div class='photo'>";
		$txt.="\t<div class='image'><table><tr><td align='center'>".$ntag."</td></tr></table></div>\n";
		if(!is_feed()) $txt.="\t<div class='exifdata'>".$this->get_exif($path,$file)."</div>\n";
		if(!is_feed()) $txt.="\t<div class='counter'>Visitas: ".$this->getCount($path,$file)."</div>\n";
		$txt.="</div>";
		$txt.="<div class='text'>".$text."</div>";

		return $txt;
	}
}

function debug($txt){
	if($_GET['preview']){
		echo "<div class='debug'><pre>$txt</pre></div>";
	}
}

function init_menu(){
	add_submenu_page('index.php', __('Image Stats'), __('Image Stats'), 'manage_options', 'PhotoBlog', 'image_stats_page');
	add_options_page('PhotoBlog','PhotoBlog','manage_options',__FILE__,'optionsPage');  
}

function optionsPage(){
     echo '<div class="wrap"><h2>Say Hi Options</h2>';
     if ($_REQUEST['submit']) {
          updateOptions();
     }
     printOptionForm();
     echo '</div>';
}
     
function printOptionForm () {
	$DOC_ROOT = get_option('DOC_ROOT');
	$DOMAIN = get_option('DOMAIN');
	?>
	<form method="post">
	<table class="form-table">
		<tr valign="top"><th scope="row">DocRoot</th><td><input type="text" name="DOC_ROOT" value="<? echo $DOC_ROOT;?>" size="40" class="code" /></td></tr>
		<tr valign="top"><th scope="row">Domain</th><td><input type="text" name="DOMAIN" value="<? echo $DOMAIN;?> " size="40" class="code" /></td></tr>
	</table>
	<p class="submit"><input type="submit" name="submit" value="Submit" /><p>
	</form>
	<?
}
 
function updateOptions() {
     $updated = false;
     if ($_REQUEST['DOC_ROOT']) {
          update_option('DOC_ROOT', $_REQUEST['DOC_ROOT']);
          $updated = true;
     }
     if ($_REQUEST['DOMAIN']) {
          update_option('DOMAIN', $_REQUEST['DOMAIN']);
          $updated = true;
     }
     if ($updated) {
           echo '<div id="message" class="updated fade">';
           echo '<p>Options Updated</p>';
           echo '</div>';
      } else {
           echo '<div id="message" class="error fade">';
           echo '<p>Unable to update options</p>';
           echo '</div>';
      }
 }

function image_stats_page(){
	global $wpdb;
?>
<table><tr valign="top"><td>
<h2>Estadisticas de las imagenes</h2>
<table><tr><td align='center'><h3>Siempre</h3></td><td align='center'><h3>Hoy</h3></td><td align='center'><h3>Ayer</h3></td></tr><tr><td valign='top'>
<table>
<?
$res = $wpdb->get_results("SELECT id,count,name,url FROM wp_photoblog_count order by count desc LIMIT 0 , 10");
foreach ($res as $fila) {
	if(preg_match('#(.*)/(.*)#', $fila->id, $valores)) list(,$path,$file)=$valores;
    $path=str_replace("http://www.laullon.com/blog/","http://photoblog.laullon.com/",$path);
	echo "<tr><td>$fila->count</td><td><a href='$fila->url'><img src='$path/thumb_$file' title='$fila->name' alt='$fila->name'/>+</a></td></tr>";
}
?>
</table>
</td><td valign='top'>
<table>
<?
$res = $wpdb->get_results("SELECT id,count,name,url FROM wp_photoblog_count_day where day=date(now()) order by count desc LIMIT 0 , 10");
foreach ($res as $fila) {
	if(preg_match('#(.*)/(.*)#', $fila->id, $valores)) list(,$path,$file)=$valores;
    $path=str_replace("http://www.laullon.com/blog/","http://photoblog.laullon.com/",$path);
	echo "<tr><td>$fila->count</td><td><a href='$fila->url'><img src='$path/thumb_$file' title='$fila->name' alt='$fila->name'/>+</a></td></tr>";
}
?>
</table>
</td><td valign='top'>
<table>
<?
$res = $wpdb->get_results("SELECT id,count,name,url FROM wp_photoblog_count_day where day=date(ADDDATE(now(), INTERVAL -1 day)) order by count desc LIMIT 0 , 10");
foreach ($res as $fila) {
	if(preg_match('#(.*)/(.*)#', $fila->id, $valores)) list(,$path,$file)=$valores;
    $path=str_replace("http://www.laullon.com/blog/","http://photoblog.laullon.com/",$path);
	echo "<tr><td>$fila->count</td><td><a href='$fila->url'><img src='$path/thumb_$file' title='$fila->name' alt='$fila->name'/>+</a></td></tr>";
}
?>
</table>
</td></tr></table>
</td><td>
<h2>Ultimos accesos</h2>
<h3>Accesos ultimas 24Hr</h3><br>
<? ultimosAccesosHoras(); ?>
<h3>Accesos RSS ultimas 24Hr</h3><br>
<? ultimosAccesosHoras(true); ?>
<h3>Accesos ultimas 24 Das</h3><br>
<? ultimosAccesosDias(); ?>
<h3>Accesos RSS ultimas Das</h3><br>
<? ultimosAccesosDias(true); ?>
</td></tr></table>
<?
}

function ultimosAccesosHoras($rss='false'){
	ultimosAccesos("SELECT date_format(FROM_UNIXTIME(id),'%H') as x,count FROM wp_photoblog_access where (rss='$rss' and id>UNIX_TIMESTAMP(ADDDATE(now(), INTERVAL -1 day))) order by id asc ");
}

function ultimosAccesosDias($rss='false'){
	ultimosAccesos("SELECT day(FROM_UNIXTIME(id)) as x,date(FROM_UNIXTIME(id)) as date, sum(count) as count FROM `wp_photoblog_access` where rss='$rss' group by date(FROM_UNIXTIME(id)) order by date asc");
}

//la query tiene que devolver almenos 2 campos... 
// count = valores de la grafica
// x = valores de la leyenda de X
function ultimosAccesos($query){
	global $wpdb;
	$res = $wpdb->get_results($query);
	//var_dump($res,$query);
	$max=1;
	foreach ($res as $fila) { 
		$chart.=$fila->count.',';
		$chart_x.='|'.$fila->x;
		$max=max($max,$fila->count);
	}
	$max=ceil($max/5)*5;
	$chart = substr($chart, 0, -1);
	$datos=split(',',$chart);
	$chart="";
	foreach ($datos as $dato) {
		$chart.=(($dato/$max)*100).',';
	}
	$chart = substr($chart, 0, -1);
	echo "<img src='http://chart.apis.google.com/chart?chs=444x180&cht=lc&chd=t:$chart&chxt=x,y&chxl=0:$chart_x|1:|0|".(($max/5)*1)."|".(($max/5)*2)."|".(($max/5)*3)."|".(($max/5)*4)."|$max&chg=8.333,20,2,4'/>";
}

function getThLastPost($args){
	global $PhotoBlog;
	extract($args);

	$rand_posts = get_posts('numberposts=5');
	
	echo $before_widget;
	echo "<div class='last_photos'>${before_title}Ultimas fotos${after_title}<p>";

	foreach( $rand_posts as $post ){
		$text=$post->post_content;
		$text=str_replace("http://www.laullon.com/blog/","http://photoblog.laullon.com/",$text);

		if(preg_match('#<img[^>]*>#s',$text,$valores)){
			list($tag)=$valores;
			if(preg_match('#src=\"(.*?)\"#s', $tag, $valores)) list(,$url)=$valores;
			if(preg_match('#(\w+://[^/]*)?(.*)#', $url, $valores)) list($url,$server,$img)=$valores;
			if(preg_match('#(.*)/(.*)#', $img, $valores)) list(,$path,$file)=$valores;
					
			if(is_string($img)){
				$res.='<a href="'.get_permalink($post->ID).'">'.$PhotoBlog->getImgThTag($path,$file,$post->post_title).'</a>';
			}
		}else{
			$res.='&nbsp;<a href="'.get_permalink($post->ID).'">'.$post->post_title.'</a>&nbsp;';
		}
	}
	echo $res;		
	echo "</p></div>";
    echo $after_widget;
}

function getThTopFivePst($args){
	global $wpdb,$PhotoBlog;
	extract($args);
	
	echo $before_widget;
	echo "<div class='top_five'>${before_title}Top Five Post${after_title}</h2><p>";
	$res = $wpdb->get_results("SELECT id,count,name,url FROM wp_photoblog_count order by count desc LIMIT 0 , 5");
	foreach ($res as $fila) {
		if(preg_match('#(.*)/(.*)#', $fila->id, $valores)) list(,$path,$file)=$valores;
		$url=str_replace("http://www.laullon.com/blog/","http://photoblog.laullon.com/",$fila->url);
		$path=str_replace("/blog/","/",$path);
		echo "<a href='$url'>".$PhotoBlog->getImgThTag($path,$file,$post->post_title)."</a>";
	}
	echo "</p></div>";
    echo $after_widget;
}

function setOptions () {
     add_option("DOC_ROOT","/home/laullon/public_html","Images Document root of web server");
     add_option("DOMAIN","http://www.laullon.com","Images server domain");
}
function unsetOptions () {
     delete_option("DOC_ROOT");
     delete_option("DOMAIN");
}

// aade unas columnas (count,image) a la lista de post en MANAGE
function addManageColumns($defaults) {
    $ks=array_keys($defaults);    
    foreach($ks as $k){
    	if($k=="title") {
    		$res['count'] = __('count');
    		$res['image'] = __('image');
    	}
    	$res[$k]=$defaults[$k];
    }
    return $res;
}

//controla las columnas
function manageColumns($column_name, $id) {
	global $post,$PhotoBlog,$wpdb;

	//var_dump( $post );
	if(preg_match('#<img[^>]*>#s',$post->post_content,$valores)) list($tag)=$valores;
	if(preg_match('#src=\"(.*?)\"#s', $tag, $valores)) list(,$url)=$valores;
	if(preg_match('#(\w+://[^/]*)?(.*)#', $url, $valores)) list($url,$server,$img)=$valores;
	if(preg_match('#(.*)/(.*)#', $img, $valores)) list(,$path,$file)=$valores;

    if( $column_name == 'image' ) {
		$path=str_replace("/blog/","/",$path);
		$ntag=$PhotoBlog->getImgThTag($path,$file,$alt);
		echo $ntag;
    } elseif( $column_name == 'count' ) {
		$cont = $wpdb->get_var("SELECT count FROM wp_photoblog_count WHERE id='$path/$file'");
		echo $cont;
    }
}

function init_widgets(){	
	if(function_exists('wp_register_sidebar_widget')){
		register_sidebar_widget("Top Five Photos", "getThTopFivePst");
		register_sidebar_widget("Get Last Five Photos", "getThLastPost");
	} else if (function_exists('register_sidebar_module') ){
		register_sidebar_widget("Top Five Photos", "getThTopFivePst");
		register_sidebar_widget("Get Last Five Photos", "getThLastPost");
	}			
}

register_activation_hook(__FILE__,"setOptions");
register_deactivation_hook(__FILE__,"unsetOptions");


add_action('admin_menu', 'init_menu' );
add_action('widgets_init','init_widgets', 1);	
add_action('plugins_loaded', $PhotoBlog);
add_filter('manage_posts_columns', 'addManageColumns');
add_action('manage_posts_custom_column', 'manageColumns', 10, 2);

$PhotoBlog = new PhotoBlog();

// RSS MEDIA

add_action('rss2_ns', 'rss2_ns');
function rss2_ns(){
	echo 'xmlns:media="http://search.yahoo.com/mrss"';
}

add_action('rss2_item', 'rss2_item');
function rss2_item(){
	global $post;
	
	//var_dump($post);
	
	if(preg_match('#<img[^>]*>#s',$post->post_content,$valores)){
		list($tag)=$valores;
		if(preg_match('#src=\"(.*?)\"#s', $tag, $valores)) list(,$url)=$valores;
		if(preg_match('#(\w+://[^/]*)?(.*)#', $url, $valores)) list(,$server,$img)=$valores;
		if(preg_match('#(.*)/(.*)#', $img, $valores)) list(,$path,$file)=$valores;

		echo "<media:thumbnail url='$server$path/thumb_$file'/>";
		echo "<media:content url='$url'/>";
	}
}

?>